/*
	(C) 1997-2001 AROS - The Amiga Research OS
	$Id: requesters.c,v 1.1.1.1 2005/03/15 15:54:21 laire Exp $
 
	Desc: Miscellaneous requester functions
	Lang: english
*/

#include <proto/graphics.h>
#include <proto/layers.h>
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/cybergraphics.h>
#include <exec/types.h>
#include <intuition/intuition.h>
#include <intuition/gadgetclass.h>
#include <intuition/imageclass.h>
#include <graphics/rpattr.h>
#include "intuition_intern.h"
#include "maybe_boopsi.h"
#include "requesters.h"

#define	DEBUG_REQUESTER(x)	;

/* free the array of gadgetlabels made in BuildEasyRequestArgs() */
void intrequest_freelabels(STRPTR *gadgetlabels, struct IntuitionBase *IntuitionBase)
{
	if (gadgetlabels)
	{
		FreeVec(gadgetlabels[0]);
		FreeVec(gadgetlabels);
	}
}


/* free the gadgets made in BuildEasyRequestArgs() */
void intrequest_freegadgets(struct Gadget *gadgets, struct IntuitionBase *IntuitionBase)
{
	while (gadgets)
	{
		struct Gadget* nextgadget = 0;
		struct Image *frame = 0;

		GetAttr(GA_Next,gadgets,(ULONG*)&nextgadget);
		GetAttr(GA_Image,gadgets,(ULONG*)&frame);

		if (frame) DisposeObject(frame);
		DisposeObject(gadgets);
		gadgets = nextgadget;
	}
}


/*****************************************************************************/


/* render a standard requester */
void render_requester(struct Requester *requester, struct IntuitionBase *IntuitionBase)
{
	struct RastPort *rp = requester->ReqLayer->rp;

	if ((requester->Flags & NOREQBACKFILL) == 0)
		SetRast(rp, requester->BackFill);

	if (requester->ImageBMap && requester->Flags & PREDRAWN)
		BltBitMapRastPort(requester->ImageBMap, 0, 0,
		                  rp, 0, 0, requester->Width, requester->Height, 0xc0);

	if (requester->ReqImage && requester->Flags & USEREQIMAGE)
		DrawImage(rp, requester->ReqImage, 0, 0);

	if (requester->ReqBorder)
		DrawBorder(rp, requester->ReqBorder, 0, 0);

	if (requester->ReqGadget)
		RefreshGList(requester->ReqGadget, requester->RWindow, requester, -1);

	if (requester->ReqText)
		PrintIText(rp, requester->ReqText, 0, 0);
}
